/* -*- buffer-read-only: t -*- vi: set ro:
#line 636
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 636
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MBOX
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 15 "bi_mbox.m4"
/* This file is part of Mailfromd.             -*- c -*-
#line 15
   Copyright (C) 2008 Sergey Poznyakoff
#line 15

#line 15
   This program is free software; you can redistribute it and/or modify
#line 15
   it under the terms of the GNU General Public License as published by
#line 15
   the Free Software Foundation; either version 3, or (at your option)
#line 15
   any later version.
#line 15

#line 15
   This program is distributed in the hope that it will be useful,
#line 15
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 15
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 15
   GNU General Public License for more details.
#line 15

#line 15
   You should have received a copy of the GNU General Public License
#line 15
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_do(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return xcalloc(NMBOXES, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + NMBOXES; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 55

#line 55
static int MBOXTAB_id;
#line 55 "bi_mbox.m4"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < NMBOXES; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}

/* number mailbox_open(string url) */
void
#line 68
bi_mailbox_open(eval_environ_t env)
#line 68

#line 68 "bi_mbox.m4"
{
#line 68
	
#line 68

#line 68
long __bi_argcnt;
#line 68
char * url;
#line 68
        char * mode;
#line 68
        char * perms;
#line 68
        
#line 68
get_string_arg(env, 1, &url);
#line 68
        get_string_arg(env, 2, &mode);
#line 68
        get_string_arg(env, 3, &perms);
#line 68
        
#line 68
get_numeric_arg(env, 0, &__bi_argcnt);
#line 68
        adjust_stack(env, __bi_argcnt + 1);
#line 68

#line 68
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 68
		prog_trace(env, "mailbox_open %s %s %s",url, ((__bi_argcnt > 1) ? mode : ""), ((__bi_argcnt > 2) ? perms : ""));;
#line 68

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 78
			env_throw_bi(env, mfe_failure, "mailbox_open", _("no more mailboxes available"))
#line 80
;
	debug1(10, "opening mailbox %s", url);
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
					env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p);
#line 111
			break;

		default:
				env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p);
#line 117
		}
	}

	/* FIXME: MU: This is ridiculous! */
	if ((flags & (MU_STREAM_READ|MU_STREAM_WRITE))
	    == (MU_STREAM_READ|MU_STREAM_WRITE)) {
		    flags &= ~(MU_STREAM_READ|MU_STREAM_WRITE);
		    flags |= MU_STREAM_RDWR;
	}
	    
	if ((__bi_argcnt > 2)) {
		/* If MU_STREAM_IRGRP is defined, the remaining three
#line 130
		   permissions flags are defined as well.
#line 130
		   FIXME: Remove ifdef when MU 2.0 is out. */
#ifdef MU_STREAM_IRGRP
		int f;
		const char *p;
			if (!(mu_parse_stream_perm_string(&f, ((__bi_argcnt > 1) ? mode : 0), &p)
#line 134
			  == 0))
#line 134
			env_throw_bi(env, mfe_range, "mailbox_open", /* FIXME: introduce mfe_inval? */
#line 134
			  _("invalid permissions (near %s)"),p)
#line 137
;
		flags |= f;
#else
			env_throw_bi(env, mfe_failure, "mailbox_open", _("this version of Mailutils does not support "
#line 140
			   "configurable mailbox permissions"));
#line 143
#endif
	}
		
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 147
			env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 150
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
			env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot open mailbox `%s': %s"),url,mu_strerror(rc));
#line 157
	}
	mu_list_create(&mp->msglist);
	
	
#line 160
do {
#line 160
  push(env, (STKVAL) (md));
#line 160
  return;
#line 160
} while (0);
}
}

/* void mailbox_close(number mbx) */
void
#line 165
bi_mailbox_close(eval_environ_t env)
#line 165

#line 165 "bi_mbox.m4"
{
#line 165
	
#line 165

#line 165

#line 165
long  md;
#line 165
        
#line 165
get_numeric_arg(env, 0, &md);
#line 165
        
#line 165

#line 165
        adjust_stack(env, 1);
#line 165

#line 165
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 165
		prog_trace(env, "mailbox_close %lu",md);;
#line 165

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < NMBOXES))
#line 169
			env_throw_bi(env, mfe_range, "mailbox_close", _("invalid mailbox descriptor"))
#line 171
;
	close_mbox(mbtab + md);
}
}

#line 187

	
/* number mailbox_messages_count(number mbx) */
void
#line 190
bi_mailbox_messages_count(eval_environ_t env)
#line 190

#line 190 "bi_mbox.m4"
{
#line 190
	
#line 190

#line 190

#line 190
long  nmbx;
#line 190
        
#line 190
get_numeric_arg(env, 0, &nmbx);
#line 190
        
#line 190

#line 190
        adjust_stack(env, 1);
#line 190

#line 190
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 190
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 190

{
	size_t count;
	int rc;
	
#line 194
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 194
	struct mf_mbox *mp;
#line 194
			
#line 194
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 194
			env_throw_bi(env, mfe_range, "mailbox_messages_count", _("invalid mailbox descriptor"))
#line 194
;
#line 194
	mp = mbtab + nmbx;
#line 194
		if (!(mp->mbox))
#line 194
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("mailbox not open"))
#line 194

#line 194
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 197
			env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 200
;
	
#line 201
do {
#line 201
  push(env, (STKVAL) (count));
#line 201
  return;
#line 201
} while (0);
}
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 206
bi_mailbox_get_message(eval_environ_t env)
#line 206

#line 206 "bi_mbox.m4"
{
#line 206
	
#line 206

#line 206

#line 206
long  nmbx;
#line 206
        long  msgno;
#line 206
        
#line 206
get_numeric_arg(env, 0, &nmbx);
#line 206
        get_numeric_arg(env, 1, &msgno);
#line 206
        
#line 206

#line 206
        adjust_stack(env, 2);
#line 206

#line 206
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 206
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 206

{
	int rc;
	mu_message_t msg;
	
#line 210
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 210
	struct mf_mbox *mp;
#line 210
			
#line 210
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 210
			env_throw_bi(env, mfe_range, "mailbox_get_message", _("invalid mailbox descriptor"))
#line 210
;
#line 210
	mp = mbtab + nmbx;
#line 210
		if (!(mp->mbox))
#line 210
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("mailbox not open"))
#line 210

#line 210
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 213
			env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 216
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 218
			env_throw_bi(env, mfe_failure, "mailbox_get_message", _("no more message slots available"))
#line 220
;
	
#line 221
do {
#line 221
  push(env, (STKVAL) (rc));
#line 221
  return;
#line 221
} while (0);
}
}

/* void mailbox_append_message(number mbx, number msg-no) */
void
#line 226
bi_mailbox_append_message(eval_environ_t env)
#line 226

#line 226 "bi_mbox.m4"
{
#line 226
	
#line 226

#line 226

#line 226
long  nmbx;
#line 226
        long  msgno;
#line 226
        
#line 226
get_numeric_arg(env, 0, &nmbx);
#line 226
        get_numeric_arg(env, 1, &msgno);
#line 226
        
#line 226

#line 226
        adjust_stack(env, 2);
#line 226

#line 226
	if (prog_trace_option & BUILTIN_MASK_mbox)
#line 226
		prog_trace(env, "mailbox_append_message %lu %lu",nmbx, msgno);;
#line 226

{
	int rc;
	mu_message_t msg;
	
#line 230
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 230
	struct mf_mbox *mp;
#line 230
			
#line 230
		if (!(nmbx >= 0 && nmbx < NMBOXES))
#line 230
			env_throw_bi(env, mfe_range, "mailbox_append_message", _("invalid mailbox descriptor"))
#line 230
;
#line 230
	mp = mbtab + nmbx;
#line 230
		if (!(mp->mbox))
#line 230
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("mailbox not open"))
#line 230

#line 230
;

	msg = bi_message_from_descr(env, msgno);
	rc = mu_mailbox_append_message(mp->mbox, msg);
		if (!(rc == 0))
#line 234
			env_throw_bi(env, mfe_failure, "mailbox_append_message", _("cannot append message: %s"),mu_strerror(rc))
#line 237
;
}
}


#line 241
void
#line 241
mbox_init_builtin()
#line 241
{
#line 241
	#line 55 "bi_mbox.m4"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes,
#line 55
NULL);
#line 68 "bi_mbox.m4"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, dtype_number, 3, 2, 0|0, dtype_string, dtype_string, dtype_string);
#line 165 "bi_mbox.m4"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 190 "bi_mbox.m4"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 206 "bi_mbox.m4"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 226 "bi_mbox.m4"
va_builtin_install_ex("mailbox_append_message", bi_mailbox_append_message, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);

#line 241 "bi_mbox.m4"
	
#line 241
}
#line 241

#line 627 "../mfd/snarf.m4"

#line 627

